<?php
require 'vendor/autoload.php'; // Ensure this path is correct
require 'config.php';

use PHPShopify\ShopifySDK;

$config = [
    'ShopUrl' => 'thehouseofjewel.myshopify.com',
    'AccessToken' => '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',
    'ApiVersion' => '2023-04', // Use the latest API version or the version you're targeting
];

$shopify = new ShopifySDK($config);

function fetchAllProducts($shopify) {
    $allProducts = [];
    $params = ['limit' => 250]; // Maximum limit per request

    do {
        $products = $shopify->Product->get($params);
        $allProducts = array_merge($allProducts, $products);

        if (isset($products) && count($products) == $params['limit']) {
            $lastProduct = end($products);
            $params['since_id'] = $lastProduct['id'];
        } else {
            break;
        }
    } while (true);

    return $allProducts;
}
// Function to update variant pricing
function updateVariantPricing($shopify, $productId, $variantId, $newPrice) {
   try {
        $shopify->ProductVariant($variantId)->put(['price' => $newPrice]);
        echo "Updated Variant ID: $variantId for Product ID: $productId with new price: $newPrice<br>";
    } catch (Exception $e) {
        echo "Error updating variant pricing: " . $e->getMessage();
    }
}

$allProducts = fetchAllProducts($shopify);

// foreach ($allProducts as $product) {
//     echo "Product ID: " . $product['id'] . " - Title: " . $product['title'] . "<br>";
// }
foreach ($allProducts as $product) {
    foreach ($product['variants'] as $variant) {
        
        // Update pricing logic here based on your requirements
        $productId = $product['id'];
       // if($productId =='7185524523110'){
        $variantId = $variant['id'];
        $currentPrice = $variant['price']; // Get current price
        
        $option1=$variant['option1'];
        $option2=$variant['option2'];
        $option3=$variant['option3'];
        $title=$variant['title'];
        $Price_variant_Wise=round(calculate_price_variant($conn,$productId,$title));
        
        $newPrice = $Price_variant_Wise; //Example: Increase price by 10%
        // Call function to update variant pricing
        updateVariantPricing($shopify, $productId, $variantId, $newPrice);
        // // Update price for each variant (example: increase price by 10%)
        // $updatedPrice = $variant['price'] * 1.1; // Custom logic to update price
        // //$shopify->Variant($variant['id'])->put(['price' => $updatedPrice]);
        
         echo "Updated Product ID: " . $product['id'] . " - Variant ID: " . $variant['id'] . " - New Price: " . $newPrice . "<br>";
        //}
    }
}
function fetchProductWeight($conn,$productId,$fetch_goldKtId){
    $sql="SELECT * FROM `tjh_product_weight` Where `productId` ='".$productId."' and `metalKtId` = '".trim($fetch_goldKtId)."'";
    $qresult = $conn->query($sql);
    if($qresult->num_rows == 0) {
        $goldWeight=0;
    }else{
        $qrow   = $qresult->fetch_assoc();
        $goldWeight = $qrow['weight'];
    }
    return $goldWeight;
}
function calculate_price_variant($conn,$productId,$title){
     $title_gold       =explode("/",$title);
     $fetch_goldColor  =$title_gold[0];
     $fetch_goldKt     =$title_gold[1];
     
     $fetch_goldColorId= fetch_goldColorId($conn,$fetch_goldColor);
     $fetch_goldKtId   = fetch_goldKtId($conn,$fetch_goldKt);
     $fetch_goldrate   = fetch_goldPricePerGram($conn,$fetch_goldColorId,$fetch_goldKtId);
     $gst_ontotalPrice= 3;
     $wastagePergram= 1000;
     $goldweight    = fetchProductWeight($conn,$productId,$fetch_goldKtId);
     
     $productGoldPrice= $fetch_goldrate * $goldweight;
     $productGoldPricewithwastage=$goldweight * $wastagePergram;
     $productGoldPricePreTAX = $productGoldPrice + $productGoldPricewithwastage;
     $productGoldPricewithGST= $productGoldPricePreTAX * $gst_ontotalPrice / 100;
     $productGoldPriceAfterTAX=$productGoldPricePreTAX + $productGoldPricewithGST;
     
    return $productGoldPriceAfterTAX;
}

function fetch_goldPricePerGram($conn,$fetch_goldColorId,$fetch_goldKtId){
         
    $sql="SELECT * FROM `tjh_metals_rate` Where  `metal_color_id` = '".trim($fetch_goldColorId)."' and `metal_kt_id` = '".trim($fetch_goldKtId)."' and `metal_id` = '1'";
     $qresult = $conn->query($sql);
     if($qresult->num_rows == 0) {
        $goldPrice=0;
    }else{
        $qrow   = $qresult->fetch_assoc();
        $goldPrice = $qrow['metal_rate'] / 10;
    }
     return $goldPrice;
}
function fetch_goldKtId($conn,$fetch_goldKt){
    $sql="SELECT * FROM `tjh_metal_kt` Where `metal_kt_description` = '".trim($fetch_goldKt)."'";
    $qresult = $conn->query($sql);
    if($qresult->num_rows == 0) {
        $goldKt=0;
    }else{
        $qrow   = $qresult->fetch_assoc();
        $goldKt = $qrow['id'];
    }
    return $goldKt;
}

function fetch_goldColorId($conn,$fetch_goldColor){
    $sql="SELECT * FROM `tjh_metal_color` Where `metal_color` = '".trim($fetch_goldColor)."'";
    $qresult = $conn->query($sql);
    if($qresult->num_rows == 0) {
        $goldColor=0;
    }else{
        $qrow = $qresult->fetch_assoc();
        $goldColor=$qrow['id'];
    }
    return $goldColor;
}
?>
